/***************************************************************************/
/*                                                                         */
/* TnWator Copyright (c) 2008 The_Nihilant                                 */
/* Any unauthorized use of this program is forbidden.                      */
/* This program is released under the GNU GPL v.3 or later.                */
/*                                                                         */
/***************************************************************************/

#include <stdio.h>
#include <unistd.h>              
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>           /* For O_* constants */

#define WATOR_SHM_C
#include "wator_shm.h"
#define WATOR_DISPLAY "./wator_display"


int* initdisplay(int rx, int ry){
 int s=shm_open(WATOR_SHM,O_RDWR|O_CREAT,S_IRUSR|S_IWUSR);
 int * buf=NULL;
 int cx=0;
 int zero=0;
 if(s==-1){perror("Cannot create POSIX Shared Memory segment\n");return NULL;}
 if(write(s,&rx,sizeof(rx))==-1){perror("Error writing to Shared Memory\n");close(s);return NULL;}
 if(write(s,&ry,sizeof(ry))==-1){perror("Error writing to Shared Memory\n");close(s);return NULL;}
 
 for(cx=0;cx<rx*ry;cx++) /* UGLY HACK! (could just do a seek! */
  if(write(s,&zero,sizeof(int))==-1)
   {perror("Error writing to Shared Memory\n");close(s);return NULL;}

 buf=mmap(NULL,2+rx*ry*sizeof(int),PROT_READ|PROT_WRITE,MAP_SHARED,s,0);
 
 if(buf==MAP_FAILED){close(s);return NULL;}
 close(s);
 if(!fork()){
  execl(WATOR_DISPLAY,WATOR_DISPLAY,NULL);
 }
 
 return buf+2;
}
